/******************************
	Picture Book program
	TAB = 4
	Shigeyuki Seko
	12/6/1999
 ******************************/

#include <Pilot.h>

#define	MaxPage 3

Int Page;

static void drawBitmap(Int x, Int y, Int id)
{
	VoidHand h;
	VoidPtr p;

	h = DmGet1Resource('Tbmp', id);
	if(h != NULL){
		p = MemHandleLock(h);
		WinDrawBitmap((BitmapPtr)p, x, y);
		MemHandleUnlock(h);
		DmReleaseResource(h);
	}
}


/********************************
	Start
 ********************************/

static void StartApplication(void)
{
	FormPtr			frm;
	FieldPtr 		opPtr;

	frm = FrmInitForm(1000);	
	FrmSetActiveForm(frm);
	FrmDrawForm(frm);

	drawBitmap(5, 20, 7000);
	Page=0;
}

static void PageUp(void)
{
	if (Page<MaxPage){
		Page=Page+1;
		drawBitmap(14, 25, 7000+Page);
	}
}

static void PageDown(void)
{
	if (Page>1){
		Page=Page-1;
		drawBitmap(14, 25, 7000+Page);
	}
}

/********************************
	Event Loop
 ********************************/

static Boolean MainFormHandleEvent(EventPtr event)
{
	Boolean		handled = false;
	Err			error;
	FormPtr		frm;

	if(event->eType == ctlSelectEvent){
   		if(event->data.ctlEnter.controlID == 5000){			/* Go Start Page */
			Page=1;
			drawBitmap(14, 25, 7000+Page);
		}
  		else if(event->data.ctlEnter.controlID == 5001){	/* Back */
			PageDown();
		}
 		else if(event->data.ctlEnter.controlID == 5002){	/* Next */
			PageUp();
		}
	}

	else if(event->eType == keyDownEvent){
	   if (event->data.keyDown.chr == pageUpChr){	/* Scroll up key presed */
			PageUp();
			handled = true;
		}

		else if (event->data.keyDown.chr == pageDownChr){	/* Scroll down key presed */
			PageDown();
			handled = true;
		}
	}

	else if (event->eType == menuEvent){	/* Menu event */
    	switch (event->data.menu.itemID){
		  case 3601:		/* about */
	        frm = FrmInitForm(3000);
            FrmDoDialog(frm);
            FrmDeleteForm(frm);
			break;
		  case 3602:						/* Go Start Page */
			Page=1;
			drawBitmap(14, 25, 7000+Page);
			break;
		  case 3603:						/* Back */
			PageDown();
			break;
		  case 3604:						/* Next */
			PageUp();
			break;
		}
		handled = true;
	}

	else if(event->eType == nilEvent){
		handled = true;
	}
	return handled;
}

/********************************
	Event Loop
 ********************************/

static void EventLoop(void)
{
	EventType	event;
	Word		error;
	short 		err;
	
	do{
		EvtGetEvent(&event, 100); 
		if(!SysHandleEvent(&event))
			if (!MainFormHandleEvent(&event))
				FrmHandleEvent(FrmGetActiveForm(), &event);
		if (MenuHandleEvent((void *)0, &event, &err)) continue;
	} 
	while (event.eType != appStopEvent);
}

/********************************
	Main Routine
 ********************************/

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
	Err error;

	if(cmd == sysAppLaunchCmdNormalLaunch){
		StartApplication();
		EventLoop();
	}
	return(0);
}
